//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * 変換ライトヘッダ
 * @author Junpee
 */

#ifndef TRANSLATION_LIGHT_H_
#define TRANSLATION_LIGHT_H_

namespace Lamp{
	class Scene;
}

namespace LampForMaya{

class TranslationAmbientLight;
class TranslationDirectionalLight;
class TranslationPointLight;

//------------------------------------------------------------------------------
/**
 * 変換ライト
 */
class TranslationLight{
friend class TranslationLightManager;
public:
	/**
	 * デストラクタ
	 */
	virtual ~TranslationLight();

	/**
	 * 分析
	 * @return 成功すればtrue
	 */
	virtual bool analyze() = 0;

	/**
	 * Lampへの変換
	 * @param scene シーン
	 * @return 成功すればtrue
	 */
	virtual bool convertToLamp(Scene* scene) = 0;

	/**
	 * オブジェクトの取得
	 * @return オブジェクト
	 */
	virtual MObject getObject() const{ return object_; }

	/**
	 * 名前の取得
	 * @return 名前
	 */
	virtual String getName() const{ return name_; }

	//--------------------------------------------------------------------------
	// RTTI
	//--------------------------------------------------------------------------
	/**
	 * アンビエントライトかどうか
	 * @return アンビエントライトならtrue
	 */
	virtual bool isAmbientLight() const{ return false; }

	/**
	 * アンビエントライトへのキャスト
	 * @return アンビエントライト。型が違えばNULLを返す。
	 */
	virtual TranslationAmbientLight* castAmbientLight() const{
		if(isAmbientLight()){
			return (TranslationAmbientLight*)this;
		}
		return NULL;
	}

	//--------------------------------------------------------------------------
	/**
	 * ディレクショナルライトかどうか
	 * @return ディレクショナルライトならtrue
	 */
	virtual bool isDirectionalLight() const{ return false; }

	/**
	 * ディレクショナルライトへのキャスト
	 * @return ディレクショナルライト。型が違えばNULLを返す。
	 */
	virtual TranslationDirectionalLight* castDirectionalLight() const{
		if(isDirectionalLight()){
			return (TranslationDirectionalLight*)this;
		}
		return NULL;
	}

	//--------------------------------------------------------------------------
	/**
	 * ポイントライトかどうか
	 * @return ポイントライトならtrue
	 */
	virtual bool isPointLight() const{ return false; }

	/**
	 * ポイントライトへのキャスト
	 * @return ポイントライト。型が違えばNULLを返す。
	 */
	virtual TranslationPointLight* castPointLight() const{
		if(isPointLight()){
			return (TranslationPointLight*)this;
		}
		return NULL;
	}

	//--------------------------------------------------------------------------

protected:
	/**
	 * コンストラクタ
	 * @param initializeDagPath 初期化するDagパス
	 * @param initializeName 初期化する名前
	 */
	TranslationLight(
		const MDagPath& initializeDagPath, const String& initializeName);

	/**
	 * ライトの分析
	 */
	virtual bool analyzeLight();

	/**
	 * レンジの計算
	 * @param decayRate 減衰率
	 * @return レンジ
	 */
	virtual float calcRange(int decayRate){
		// 減衰無し
		if(decayRate == 0){
			return 1.84467435e+019f;
		}
		// 輝度を強さとする
		float luminance = exportColor_.r * 0.298912f +
			exportColor_.g * 0.586611f + exportColor_.b * 0.114477f;
		// 一次減衰
		if(decayRate == 1){
			return minimumLightPower * luminance;
		// 二次減衰
		}else if(decayRate == 2){
			return Math::sqrt(minimumLightPower * luminance);
		}
		return 0.f;
	}

	/// Dagパス
	MDagPath dagPath_;
	/// オブジェクト
	MObject object_;
	/// 名前
	String name_;
	/// ライトカラー
	Color3f color_;
	/// 出力カラー
	Color3f exportColor_;
	/// ライト強度
	float intensity_;
	/// ライトマスク
	int lightMask_;
	/// 表示フラグ
	bool visibility_;

	/// 最小ライト強度
	static float minimumLightPower;

private:
	// コピーコンストラクタの隠蔽
	TranslationLight(const TranslationLight& copy);

	// 代入コピーの隠蔽
	void operator =(const TranslationLight& copy);

};

//------------------------------------------------------------------------------
} // End of namespace LampForMaya
#endif // End of TRANSLATION_LIGHT_H_
//------------------------------------------------------------------------------

